<template>
    <div
        v-if="data"
        class="page-container"
    >
        <div class="shop-title">
            Shops
        </div>
        <div class="row mb-4 align-items-end justify-content-md-center">
            <div class="col-md-6">
                <div class="sort-title">
                    Sort By:
                </div>
                <b-form-select
                    v-model="selected"
                    :options="sortOptions"
                    class="form-control select-tags"
                    style="background-color: white"
                    @change="loadData"
                />
            </div>
            <div class="col-md-6">
                <div class="search-container justify-content-md-end justify-content-start">
                    <b-form-input
                        v-model="searchQuery"
                        class="my-input"
                        placeholder="Search by domain or email"
                    />
                    <button
                        class="btn blue-btn"
                        @click="loadData"
                    >
                        Search
                    </button>
                </div>
            </div>
        </div>
        <div
            v-if="shops"
            class="table-responsive"
            :class="{'loading-md': loading}"
        >
            <table
                v-if="!isShopify"
                class="table-hover"
            >
                <thead class="table-header">
                    <tr>
                        <th class="reminders-text">
                            Domain
                        </th>
                        <th>App Installed</th>
                        <!-- <th>Status</th> -->
                        <th>30 days Revenue</th>
                        <th>30 days SMS Cost</th>
                        <th>Plan</th>
                        <th>SMS Balance</th>
                        <th>Total Revenue</th>
                        <th>Billing Date</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody
                    v-if="shops.length < 1"
                    class="table-body"
                >
                    <tr class="table-body-row">
                        <td
                            class="not-found-text"
                            colspan="10"
                        >
                            Not Found
                        </td>
                    </tr>
                </tbody>
                <tbody
                    v-else
                    class="table-body"
                >
                    <tr
                        v-for="(shop, index) in shops"
                        :key="index"
                        class="table-body-row"
                    >
                        <th class="first-column">
                            <a
                                :href="shop.site_url"
                                class="shop-link"
                                target="_blank"
                            >{{ shop.site_url }}</a>
                            <div class="last-seen">
                                {{ shop.site_url }}
                            </div>
                        </th>
                        <th>
                            <span
                                v-if="shop.app_installed"
                                class="bg-success"
                            >yes</span>
                            <span
                                v-else
                                class="bg-danger"
                            >
                                no
                            </span>
                        </th>
                        <!-- <th>
                            <span
                                v-if="shop.status"
                                class="bg-success"
                            >active</span>
                        </th> -->
                        <th>${{ shop.revenue_30_days }}</th>
                        <th>${{ shop.sms_cost_30_days }}</th>
                        <th>
                            <span
                                v-if="shop.plan"
                                class="success"
                            > {{ shop.plan }}</span>
                            <span
                                v-else
                                class="danger"
                            >Not Selected</span>
                        </th>
                        <th v-if="shop.sms_balance === null">
                            $0.00
                        </th>
                        <th v-else>
                            ${{ parseFloat(shop.sms_balance).toFixed(2) }}
                        </th>
                        <th>${{ shop.total_revenue }}</th>
                        <th> {{ shop.plan_expires_on ? $formatter.dateFormat(shop.plan_expires_on) : `\u2013`}}  </th>
                        <th>
                            <div class="actions">
                                <button
                                    class="btn light-blue-btn table-btn"
                                    @click="loginToShop(shop.id)"
                                >
                                    <i class="fa fa-sign-in" />
                                    Login
                                </button>
                                <router-link
                                    :to="'/admin/shops/' + shop.id"
                                    class="btn btn-primary table-btn"
                                >
                                    <i class="fa fa-pencil" />
                                </router-link>
                                <button
                                    class="btn red-button table-btn"
                                    @click="$bvModal.show('bv-modal-shop'+ shop.id)"
                                >
                                    <i class="fa fa-trash" />
                                </button>
                            </div>
                        </th>
                        <b-modal
                            :id="'bv-modal-shop'+ shop.id"
                            size="md"
                            hide-backdrop
                            content-class="shadow"
                            :title="`Are you sure you want to delete ${shop.site_name} shop?`"
                            hide-footer
                        >
                            <button
                                type="button"
                                class="btn red-button"
                                @click="[deleteShop(shop.id), $bvModal.hide('bv-modal-shop'+ shop.id)]"
                            >
                                Yes
                            </button>
                            <button
                                type="button"
                                class="btn light-blue-btn delete-modal"
                                @click="$bvModal.hide('bv-modal-shop'+ shop.id)"
                            >
                                No
                            </button>
                        </b-modal>
                    </tr>
                </tbody>
            </table>
            <table
                v-else
                class="table-hover"
            >
                <thead class="table-header">
                    <tr>
                        <th class="reminders-text">
                            Domain
                        </th>
                        <th>App Installed</th>
                        <!-- <th>Status</th> -->
                        <th>30 days Revenue</th>
                        <th>30 days SMS Cost</th>
                        <th>Total Revenue</th>
                        <th>Billing On</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody
                    class="table-body"
                >
                    <tr
                        v-if="shops.length < 1"
                        class="table-body-row"
                    >
                        <td
                            class="not-found-text"
                            colspan="10"
                        >
                            Not Found
                        </td>
                    </tr>
                    <tr
                        v-for="(shop, index) in shops"
                        v-else
                        :key="index"
                        class="table-body-row"
                    >
                        <th class="first-column">
                            <a
                                :href="shop.shop_url"
                                class="shop-link"
                                target="_blank"
                            >{{ shop.shop_url }}</a>
                            <div class="last-seen">
                                {{ shop.domain }}
                            </div>
                        </th>
                        <th>
                            <span
                                v-if="shop.app_installed"
                                class="bg-success"
                            >yes</span>
                            <span
                                v-else
                                class="bg-danger"
                            >
                                no
                            </span>
                        </th>
                        <!-- <th>
                            <span
                                v-if="shop.status"
                                class="bg-success"
                            >active</span>
                        </th> -->
                        <th>${{ shop.revenue_30_days }}</th>
                        <th>${{ shop.sms_cost_30_days }}</th>
                        <th>${{ shop.total_revenue }}</th>
                        <th>{{ $formatter.dateFormat(shop.billing_on) }}</th>
                        <th>
                            <div class="actions">
                                <button
                                    class="btn light-blue-btn table-btn"
                                    @click="loginToShop(shop.id)"
                                >
                                    <i class="fa fa-sign-in" />
                                    Login
                                </button>
                                <router-link
                                    :to="'/admin/shops/' + shop.id"
                                    class="btn btn-primary table-btn"
                                >
                                    <i class="fa fa-pencil" />
                                </router-link>
                                <button
                                    class="btn red-button table-btn"
                                    @click="$bvModal.show('bv-modal-shop'+ shop.id)"
                                >
                                    <i class="fa fa-trash" />
                                </button>
                            </div>
                        </th>
                        <b-modal
                            :id="'bv-modal-shop'+ shop.id"
                            size="md"
                            hide-backdrop
                            content-class="shadow"
                            :title="`Are you sure you want to delete ${shop.site_name} shop?`"
                            hide-footer
                        >
                            <button
                                type="button"
                                class="btn red-button"
                                @click="[deleteShop(shop.id), $bvModal.hide('bv-modal-shop'+ shop.id)]"
                            >
                                Yes
                            </button>
                            <button
                                type="button"
                                class="btn light-blue-btn delete-modal"
                                @click="$bvModal.hide('bv-modal-shop'+ shop.id)"
                            >
                                No
                            </button>
                        </b-modal>
                    </tr>
                </tbody>
            </table>
        </div>
        <paginate
            v-if="pageCount > 1"
            v-model="pageNumber"
            :page-count="pageCount"
            :prev-text="'Previous'"
            :click-handler="loadData"
            :next-text="'Next'"
            :container-class="'pagination'"
        />
    </div>
</template>

<script>
import shops from '../../mixins/admin/shops.service';
import {mapState} from 'vuex'
export default {
    name: "AdminShops",
    mixins: [shops],
    data() {
        return {
            data: null,
            searchQuery: '',
            shops: null,
            deleteModal: false,
            loading: true,
            pageNumber: 1,
            sortOptions: [
                { text: 'Сreated Date', value: null},
                { text: 'Billing Date', value: 'billing-date'},
                { text: 'Month Revenue', value: 'month-revenue' },
                { text: 'Total Revenue', value: 'total-revenue' },
                { text: 'SMS Month Cost', value: 'sms-month-cost'},
            ],
            selected: null,
        }
    },
    computed: {
        ...mapState(['platform']),
        pageCount() {
            return Math.ceil(this.data.total / this.data.limit)
        },
        isShopify() {
            return this.platform === 'shopify'

        },
    },
    created() {
        this.loadData()

    },
    mounted() {
        document.addEventListener('keyup', (e) => {
            if(e.keyCode === 13) this.loadData()
        })
    },
    methods: {
        async loadData() {
            if(!this.loading) this.loading = true
            try {
                const { data } = await this.getShops({page: this.pageNumber, search: this.searchQuery, sort: this.selected})
                this.data = data;
                this.shops = data.data;
            } catch(err) {
                console.log(err)
            }
            this.loading = false
        },
        async loginToShop(id) {
            await this.login(id).then(res => {
                $cookies.set('userToken', res.data.token)
                let routerData = this.$router.resolve('/dashboard')
                window.open(routerData.href, '_blank');
            })
        },
        async deleteShop(id) {
            await this.delete(id).then(res => {
                this.loadData()
                this.$notify({
                    type: 'success',
                    title: 'Deleted'
                });
            })
        }
    }
}
</script>

<style scoped lang="scss">
@import "resources/css/colors.scss";
.actions {
    display: flex;
    align-items: center;
}
.shop-link {
    margin-left: 10px;
    overflow: hidden;
    white-space: nowrap;
    width: 215px;
    display: block;
    text-overflow: ellipsis;
}

.delete-modal {
    padding: 10px 20px !important;

}

.text-right {
    display: flex;
    justify-content: flex-end;
    align-items: flex-end;
}

.not-found-text {
    text-align: center;
    padding: 10px;
}

.not-found-tr {
    background-color: #fbfcfd;
}

.select-tags {
    max-width: 150px;
}

// .table-hover {
//     min-width: 1200px;
// }

.my-input {
    max-width: 200px;
    margin-right: 10px;

}

.select-tags {
    margin-top: 10px;
}

.no-data-container {
    display: flex;
}

.light-blue-btn {
    padding: 5px 10px;
}

.table-btn {
    padding: 5px 10px;
    margin-left: 4px;
}

.bg-success {
    background-color: $green;
    padding: 5px 10px;
    color: white;
    border-radius: 5px;
}

.danger {
    color: $red-color;
    font-weight: bold;
}

.success {
    color: $green;
    font-weight: bold;
    text-transform: capitalize;
}

.bg-danger {
    background-color: $red-color;
    padding: 5px 10px;
    color: white;
    border-radius: 5px;
}

.first-column {
    text-align: left;
}

.sort-title {
    margin-top: 10px;
    font-weight: 600;
}

.search-container {
    display: flex;
    margin-top: 10px;
    align-items: center;
}

.page-container {
    padding-top: 40px;
    @media(max-width: 770px) {
        padding-top: 80px;
    }
}

.shop-title {
    font-size: 28px;
    color: $blue-color;
    margin-bottom: 15px;
}
.loading-md {
    &::after {
        top: 100px;
    }
}
.table-hover thead th  {
    @media(max-width: 1175px) {
        max-width: 75px;
    }
}
</style>
